# Løsningsforslag til oppgave 3.
# Det kan forekomme metoder og instansvariable som det ikke er spurt etter

# Oppgave 18 Klassen Fylke

class Fylke:
    def __init__(self, fnr, fylkesnavn):
        self._navn = fylkesnavn
        self._nummer = fnr
        self._kommuneliste = []

    def antall_kommuner(self):
        return len(self._kommuneliste)  

    def legg_til_kommune(self, kommune):
        self._kommuneliste.append(kommune)

# *** slutt oppgave 18 *** 

# Oppgave 21 Infometoder i Fylke:

    def info(self):
        tekst = self._navn + '('+ self._nummer + '):'
        for k in self._kommuneliste:
            tekst = tekst + ' ' + str(k) + ','
        return tekst
 
    def kortinfo(self):
        return self.__str__() + " har " + str(len(self._kommuneliste)) + " kommuner."

    def __str__(self):
        return self._nummer + ' ' + self._navn
    
# *** slutt oppgave 21 ***
    
# Denne er det vel ikke eksplisitt spurt etter, men kan være nyttig likevel
# Ikke trekk for dem som har brukt instansvariabelen direkte utenfor klassen
   
    def navn(self):
        return self._navn
    
    
# Oppgave 19 Klassen Kommune
class Kommune:
    def __init__(self, parameterliste):
        # format til parameterlista (eks. fra oppgaveteksten):
        # ['1111', 'Sokndal', 'Hauge', 'Rogaland', '3 324', '294,98']
        self._parametre = parameterliste

    
    def fylkesnavn(self):
        return self._parametre[3]
    def kommuneNr(self):
        return self._parametre[0]
    def kommuneNavn(self):
        return self._parametre[1]

# Oppgave 20 Metoder i Kommune
    def __str__(self):
        return self.kommuneNr() + " " + self.kommuneNavn() + " i " + self.fylkesnavn()
        
    def settFylkesref(self, fylkeref):
        self._fylke = fylkeref

# Første deloppgave i 23 Opprette datastrukturen med fylker og kommuner:
# Lag en metode fylkesnr i klassen Kommune som returnerer en tekststreng (str)
# med de to første sifferne (tegnene) i kommunenummeret.
 
    def fylkesNr(self):
        return self._parametre[0][:2]

# Oppgave 22 Lese inn kommuneinformasjon
def les_kommuneinfo(filnavn):
    liste = []
    fil = open(filnavn)
    for linje in fil:
        liste.append(linje.strip().split("\t"))
    return liste

# Oppgave 23 Opprette datastrukturen med fylker og kommuner; resten, (se også fylkesNr() i Kommune
kommuneinfo = les_kommuneinfo("kommuneliste.txt")
fylker = {}
kommuner = []
for infolinje in kommuneinfo:
    kommune = Kommune(infolinje)
    kommuner.append(kommune)
    fylkenr = kommune.fylkesNr()
    fylkesnavn = kommune.fylkesnavn()
    if fylkenr not in fylker:
        fylker[fylkenr] = Fylke(fylkenr, kommune.fylkesnavn())
    fylker[fylkenr].legg_til_kommune(kommune)
    kommune.settFylkesref(fylker[fylkenr])
# *** slutt oppgave 23 ***

# Oppgave 24 Testprogram
# Finne fylke(r) med flest kommuner
maksk = 0
for f in fylker:
    if fylker[f].antall_kommuner() > maksk:
        flest_kommuner = []
        flest_kommuner.append(fylker[f])
        maksk = fylker[f].antall_kommuner()
    elif fylker[f].antall_kommuner() == maksk:
        flest_kommuner.append(fylker[f])
print("Fylke(r) med flest kommuner: ")
for f in flest_kommuner:
    print(f.kortinfo())

# Finne kommuner med likt navn:
kommuneOrdb = {}
for k in kommuner:
    if k.kommuneNavn() not in kommuneOrdb:
        kommuneOrdb[k.kommuneNavn()] = []
    kommuneOrdb[k.kommuneNavn()].append(k)

print("Kommuner med samme navn:")
for k in kommuneOrdb:
    if len(kommuneOrdb[k]) > 1:
        for kmn in kommuneOrdb[k]:
            print(kmn)

# ###################################################################
# Det er ingen fylker i Norge som har samme antall, 51, som Viken,
# Men la oss sjekke at dette funker hvis det hadde vært flere
# NB!!! Dette er det ikke spurt etter, tar det med her for testens skyld
# Vi øker antallet til fylke 18 Nordland til det har samme antall som fylke 30 Viken

kommune = kommuner[5]
while fylker["18"].antall_kommuner() != fylker["30"].antall_kommuner():
    fylker["18"].legg_til_kommune(kommune)
# Så kommer samme kode som ovenfor
maksk = 0
for f in fylker:
    if fylker[f].antall_kommuner() > maksk:
        flest_kommuner = []
        flest_kommuner.append(fylker[f])
        maksk = fylker[f].antall_kommuner()
    elif fylker[f].antall_kommuner() == maksk:
        flest_kommuner.append(fylker[f])

print("KUN TEST Fylke(r) med flest kommuner: ")
for f in flest_kommuner:
    print(f.kortinfo())














